using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace info.hostip {
	public class IpLocation {
		private string mCity;
		private string mCountry;
		private string mCountryCode;
		private decimal mLon;
		private decimal mLat;

		public string City {
			get {
				return mCity;
			}
		}

		public string Country {
			get {
				return mCountry;
			}
		}

		public string CountryCode {
			get {
				return mCountryCode;
			}
		}

		public decimal Lon {
			get {
				return mLon;
			}
		}

		public decimal Lat{
			get {
				return mLat;
			}
		}

		public void Parse(string ip) {
			XmlTextReader reader = new XmlTextReader("http://api.hostip.info/?ip=" + ip);
			while (reader.Read()) {
				if (reader.IsStartElement()) {
					if (reader.Name == "gml:name") {
						mCity = reader.ReadString();
					}
					if (reader.Name == "countryName") {
						mCountry = reader.ReadString();
					}
					if (reader.Name == "countryAbbrev") {
						mCountryCode = reader.ReadString();
					}
					if (reader.Name == "gml:coordinates") {
						string[] parts = reader.ReadString().Split(new char[] { ',' });
						mLon = decimal.Parse(parts[0]);
						mLat = decimal.Parse(parts[1]);
					}
				}
			}
		}
	}
}
